/*****************************************************************************
CONST.H: constants used throughout EDITSS
*****************************************************************************/

#define VERSION "EDITSS V2.1"	/* version string */

#define MAXLINELEN 150			/* max line length of files */
#define MAXSHIPLEN 800

#define NONE -1		 			/* value for tri_state troolean */
#define NOPOINT -666

#define DM_NONE -1				/* Drawmodes */
#define DM_ONERUBBER 1
#define DM_TWORUBBER 2
#define DM_NEW 3
#define DM_DRAG 4

#define PM_MAX 500				/* Min and Max sizes for drawarea */
#define PM_MIN 200
#define SPM_SIZE 60 				/* Small drawing area size */

#define MAXPOINTS 24				/* Max/min number of points & specials */
#define MINPOINTS 3
#define MAXGUNS 3
#define MAXLIGHTS 3
#define MAXRACK 4
#define MAXNAME 40				/* Max name / author field length */
#define MAXAUTHOR 40

#define MG 1						/* Symbolic names for shipshape fields */
#define EN 2
#define LG 4
#define RG 8
#define LL 16
#define RL 32
#define MR 64
#define NM 128
#define AU 256

#define BUFSTEP 4096				/* PostScript constants used */
#define SCALE 2
#define SPACING 40*SCALE
#define TITLEPOS 19*SCALE
#ifdef LETTER						/* 8.5" x 11" */
#define XSIZE 612
#define YSIZE 792
#else 								/* Use A4 if LETTER is not defined */
#define XSIZE 595
#define YSIZE 841
#endif
#define BORDER 72
#ifndef DEFAULTFORMAT
#define DEFAULTFORMAT 1
#endif


